module Ribbon::Intercom
  module Client::SDK::Adapters
    class HttpAdapter < Adapter
      autoload(:Connection, 'ribbon/intercom/client/sdk/adapters/http_adapter/connection')

      attr_reader :connection

      def connect(*args)
        @_connection_args = args.dup
      end

      def connected?
        !!connection
      end

      def connection
        @__connection ||= Connection.new(*@_connection_args)
      end

      ##
      # Send the encoded packet up to the service via an HTTP PUT.
      def send_packet!(encoded_packet)
        response = connection.put(
          headers: headers,
          body:    encoded_packet
        )

        Adapter::Response.new(response.body, response.code.to_i, response)
      end
    end # HttpAdapter
  end # Client::SDK::Adapters
end # Ribbon::Intercom