require 'set'

module Ribbon::Intercom
  class Packageable
    module Mixin
      class << self
        def included(base)
          base.extend(ClassMethods)
        end
      end

      module ClassMethods
        def package_with(*args)
          args.map { |m| _package_with_methods << m.to_sym }
        end

        def _package_with_methods
          @__package_with_methods ||= [].to_set
        end
      end # ClassMethods

      ##
      # Returns the package data for the instance as a hash.
      def package_data
        self.class._package_with_methods.map { |meth| [meth, public_send(meth)] }.to_h
      end
    end # Mixin
  end # Service::Subject
end # Ribbon::Intercom