module Ribbon::Intercom
  class Packet
    class MethodQueue
      ##
      # Enqueue a method with it's arguments.
      # Supports method chaining.
      def enqueue(name, *args)
        self.tap { _queue << [name, *Utils.sanitize(args)] }
      end

      ##
      # Iterate through the methods and arguments.
      def each(&block)
        _queue.each(&block)
      end

      def empty?
        _queue.empty?
      end

      private

      def _queue
        @__queue ||= []
      end
    end # MethodQueue
  end # Packet
end # Ribbon::Intercom