module Ribbon::Intercom
  class Service
    module Channel::Stores
      class Store
        def open_channel(params={})
          Channel.new(self, params)
        end

        def healthy?
          token_exists?('healthcheck')
          true
        rescue
          false
        end

        def token_exists?(token)
          raise NotImplementedError
        end

        def lookup_channel(token)
          raise NotImplementedError
        end

        def persist(channel)
          raise NotImplementedError
        end

        def delete(channel)
          raise NotImplementedError
        end

        def with_lock(channel, &block)
          raise NotImplementedError
        end
      end # Store
    end # Channel::Stores
  end # Service
end # Ribbon::Intercom
