module Ribbon::Intercom
  module Utils::Mixins
    module MockSafe
      ##
      # Return a mock safe version of this package.
      def mock_safe
        dup.tap { |obj| obj.mock_safe! }
      end

      ##
      # Make this package mock safe.
      def mock_safe!
        unless mock_safe?
          @_mock_safe = true

          # For RSpec: Allow any method to be mocked on this instance.
          define_singleton_method(:respond_to?) { |*args| true }
        end
      end

      def mock_safe?
        !!@_mock_safe
      end
    end # MockSafe
  end # Utils::Mixin
end # Ribbon::Intercom